from ti_system import *
from random import *

black=(0,0,0)
grey=(200,200,200)
red=(255,0,0)
blue=(0,0,255)

def arc(r):
  if r==0:
    x=(i-0.5)*w
    y=(j-0.5)*w
    draw_arc(x,y,w,w,0,90)
    x=(i+0.5)*w
    y=(j+0.5)*w
    draw_arc(x,y,w,w,180,90)
  else:
    x=(i-0.5)*w
    y=(j+0.5)*w
    draw_arc(x,y,w,w,0,-90)
    x=(i+0.5)*w
    y=(j-0.5)*w
    draw_arc(x,y,w,w,90,90)  

set_window(-65,265,-10,210)
use_buffer()

def frame():
  set_color(red)
  set_pen("medium","solid")
  draw_rect(-1,0,201,201)
  set_pen("thin","solid")

n=0
r=True
rnd=[randint(0,1)]

key=""
while key!="esc":
  w=200/(2**n)
  clear(-65,-10,318,212)
  k=0
  for i in range(2**n):
    for j in range(2**n):
      x=rnd[k]*w
      k+=1
      set_color(blue)
      if r:
        set_color(grey)
        draw_rect(w*i,w*j,w,w)
        set_color(blue)
      arc(x)
  frame()
  set_color(black)
  draw_text(-60,-5,str(4**n))
  paint_buffer()
  
  key=""
  while key not in {"esc","enter","down","up","left","right"," ","tab"}:
    key=get_key(1)
  if key == "tab":
    r = not r
  else:
    if key == "down":
      n=max(0,n-1)
    if key == "up":
      n=min(5,n+1)
    rnd=[randint(0,1) for i in range(4**n)]
